Description

I'm in a situation where pickling an object to a file would be greatly helpful, but it seems swig objects don't want to be pickled. The
test script below illustrates this.

import gammalib, pickle
a = gammalib.GEnergy(1, TeV")
with open('test.pickle','wb') as f :
pickle.dump( a, f, pickle.HIGHEST_PROTOCOL )

results in

Traceback (most recent call last):
File "<stdin>", line 4, in <module>
TypeError: can't pickle SwigPyObject objects

From this link:

http://stackoverflow.com/questions/9310053/how-to-make-my-swig-extension-module-work-with-pickle

it looks like the only thing missing is __setstate_and __getstate__in the swig interface. However, | think each class would require
a unique pair of functions, so its not a small task.

History

#1 - 03/01/2017 10:12 PM - Knodlseder Jiirgen

Funny, | stumbled over exactly the same problem today wink.png

| agree that pickling should be made possible.

#2 - 03/10/2017 06:05 PM - Kelley-Hoskins Nathan

| guess also working with json would be nice as well. | find that | often need to read/write GEnergy and GSkyDir to a text file with json, so | have to
resort to simpler conversions. I'd be interested in working on this feature once I've submitted my thesis in a few weeks.

#3 - 06/22/2018 12:52 PM - Knddliseder Jiirgen
- Status changed from New to In Progress

- Assigned To set to Knddlseder Jiirgen

- Target version set to 1.6.0

- % Done changed from 0 to 10

| started to implement the __getstate_and __setstate_ methods for all Python classes. To make sure that the methods work as expected, pickeling
tests were added to the unit tests.
http://stackoverflow.com/questions/9310053/how-to-make-my-swig-extension-module-work-with-pickle

So far the xml module is complete, and the obs module is complete with the exception of the GCaldb class

| also started to work on the cta module, the support module, the sky module, the models module and the opt module.

#4 - 06/26/2018 12:11 PM - Knédlseder Jiirgen
- % Done changed from 10 to 20

The following modules are now fully pickable:

o fits
® obs
e xml

Some classes of the following modules are already pickable:

model
opt

sky
inst/cta

The following modules were not yet treated:

app

base (not sure that we need to treat this module)

linalg

numerics

support

template (should add pickability to templates for the future)
test (not sure that we need to treat this module)

VO

xspec

#5 - 06/26/2018 09:36 PM - Knodlseder Jiirgen
- % Done changed from 20 to 30

The following modules are now fully pickable:
o fits
® obs
e model
* xml

Some classes of the following modules are already pickable:

® opt
® sky
e inst/cta

The following modules were not yet treated:

app

base (not sure that we need to treat this module)

linalg

numerics

support

template (should add pickability to templates for the future)
test (not sure that we need to treat this module)

VO

xspec

#6 - 06/27/2018 11:44 PM - Knodlseder Jiirgen

As a hint, the following code may be used to write successive FITS files for bit-to-bit comparison:

i=0

while gammalib.GFilename('test_pha_pickeling%d.fits' % i).exists():
i+=1

fits.saveto('test_pha_pickeling%d.fits' % i)

and the following command provides a bit-to-bit comparison in the terminal

$ diff -y <(xxd test/test_pha_pickeling2.fits) <(xxd test/test_pha_pickeling3.fits)

#7 - 06/28/2018 12:21 AM - Knédlseder Jiirgen
- % Done changed from 30 to 40

The following modules are now fully pickable:

o fits
obs
model
sky
xml
® xspec
Some classes of the following modules are already pickable:

e opt
¢ inst/cta (almost finished)

The following modules were not yet treated:

app

base (not sure that we need to treat this module)
linalg

numerics

support

template (should add pickability to templates for the future)
test (not sure that we need to treat this module)
VO

inst/lat

inst/com

inst/mwl

#8 - 06/28/2018 10:31 AM - KnddlIseder Jiirgen
- % Done changed from 40 to 50

The CTA module is now completed, except of performance table and vector IRF formats that are not used anymore, and the cube internal classes
that are unlikely pickled. So for most use cases, pickeling is now fully supported.

I now continue with the implementation of pickeling in the app module so that pickeling of cscripts will become possible.

#9 - 06/28/2018 04:44 PM - Knodlseder Jiirgen
- % Done changed from 50 to 60

The following modules are now fully pickable:

o fits
® obs
e model
® sky
e xml
® Xspec

Some classes of the following modules are already pickable:
¢ app (only GLog class missing)
® opt

e inst/cta (almost finished)

The following modules were not yet treated:
base (not sure that we need to treat this module)

linalg

numerics

support

template (should add pickability to templates for the future)
test (not sure that we need to treat this module)

VO

inst/lat

inst/com

inst/mwl

#10 - 06/29/2018 11:44 AM - Knédlseder Jirgen
- % Done changed from 60 to 70

| implemented pickling on the ctools side. | added pickling unit tests for cscaldb, cslightcrv and cstsmapsplit to make sure that pickling works for the
three base classes cscript, csobservation and cslikelihood.

This means that multiprocessing should now be possible.

The code is in the integration branch since I'm still doing the integration tests.

#11 - 06/29/2018 01:45 PM - Knédlseder Jiirgen

Code is now in devel. So far there are no __getstate__and __setstate_ methods in the cscripts, but they are eventually needed to make sure that all
class members are properly handled (not sure about this).

#12 - 07/02/2018 12:30 PM - KnddlIseder Jiirgen

The following modules are now fully pickable:

o fits

e obs

e opt

e model

e sky

e xml

® Xspec

e inst/mwl
¢ template

The following modules are considered complete, although not fully pickable:

inst/com (not pickable: GCOMIaq, GCOMInstChars, GCOMSelection, GCOMStatus)

inst/cta (not pickable: GCTAAeffArf, GCTAAeffPerfTable, GCTABackgroundPerfTable, GCTACubeSourceDiffuse, GCTACubeSourcePoint,
GCTAEdispPerfTable, GCTAEdispRmf, GCTAPsfPerfTable, GCTAPsfVector)

inst/lat (not pickable: GLATEventAtom, GLATEventBin, GLATResponse)

app (not pickable: GLog)

Some classes of the following modules are already pickable:
. ey

The following modules were not yet treated:
* base (not sure that we need to treat this module)

e linalg
® numerics
® support
e test (not sure that we need to treat this module)
* VO

#13 - 12/12/2018 02:29 PM - KnddlIseder Jiirgen
- Status changed from In Progress to Closed

- % Done changed from 70 to 100

For the time being, the pickling support is sufficient.
